import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class jasp here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class jasp extends enemies
{
    
    private int vSpeed=0;
    private int acceleration=2;
    private int speed=1;
    
    private int spriteHeight = getImage().getHeight();
    private int spriteWidth = getImage().getWidth();
    private int lookForGroundDistance = (int)spriteHeight/2;
    private int lookForEdge = (int)spriteWidth/2;
    
    private int animationCount;
    
    GreenfootImage jaspR = new GreenfootImage("jaspR.png");
    GreenfootImage jaspL = new GreenfootImage("jaspL.png");
    
    /**
     * Act - do whatever the jasp wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        checkFall();
        move();
        
        if(speed<0)
        {
          if(animationCount % 4 == 0)  
          animateLeft();
        }
        else
        {
          if(animationCount % 4 == 0) 
            animateRight();
        }
        
        animationCount ++;
    }    
    
    public void move ()
    {
      Actor ground = getOneObjectAtOffset(lookForEdge, lookForGroundDistance, platform_big.class);
      if (ground == null)
       {
         speed *= -1;
         lookForEdge *= -1;
        }
        else
        {
          move(speed);
        }
    }
   
    public void fall()
    {
        /**
    *процедура падения
    */
        setLocation( getX(),getY()+vSpeed);
        if(vSpeed<=9)
        {
        vSpeed=vSpeed+acceleration;
    }
    
    }


    

    public boolean onGround()
    {
         /**
    *проверка на положение
    */
        int spriteHeight=getImage().getHeight();
        int lookForGround=(int)(spriteHeight/2+5);
        
        Actor ground = getOneObjectAtOffset(0, lookForGround, platform.class);
        if( ground==null)
        {
            
            return false;
           
        }
        else
        {
            moveTooGround(ground);
            
            return true;
        }
    }
public void checkFall()
{ /**
    *проверка на положение обьекта- на земле или в воздухе
    *если в воздухе то процедура fall
    */
    if (onGround())
    {
        vSpeed=0;
        
    }
    else
    {
        
        fall();
    }
}

public void moveTooGround(Actor ground)
{ /**
    
    *двишает обьект на поверхность платформы
    */
    int groundHeight=ground.getImage().getHeight();
    int newY=ground.getY()-(groundHeight+getImage().getHeight())/2+15;
    
    setLocation( getX(), newY);
    
    
}

public void animateRight()
{
  setImage(jaspR);
}

public void animateLeft()
{
  setImage(jaspL);
}
}
